package com.vizteck.gokadauser.Fragments;

import android.app.DatePickerDialog;
import android.app.ProgressDialog;
import android.content.Intent;
import android.graphics.Typeface;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.design.widget.TextInputLayout;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.Toast;

import com.vizteck.gokadauser.Activities.Main;
import com.vizteck.gokadauser.Activities.Root;
import com.vizteck.gokadauser.R;
import com.vizteck.gokadauser.globals.Constants;
import com.vizteck.gokadauser.globals.ErrorMessages;
import com.vizteck.gokadauser.utilities.LucidaGrande;
import com.vizteck.gokadauser.utilities.Utilities;
import com.vizteck.gokadauser.webservices.WebServicesCallback;
import com.vizteck.gokadauser.webservices.WebServicesClient;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import butterknife.Unbinder;
import co.paystack.android.Paystack;
import co.paystack.android.PaystackSdk;
import co.paystack.android.Transaction;
import co.paystack.android.exceptions.ExpiredAccessCodeException;
import co.paystack.android.model.Card;
import co.paystack.android.model.Charge;

/**
 * Created by AmmarShahid on 4/03/2016.
 */
public class LoginAddCreditCardFragment extends Fragment {



    @BindView(R.id.btn_finish)
    Button btnFinish;
    @BindView(R.id.btn_back)
    ImageButton btnBack;
    @BindView(R.id.lbl_heading_payment)
    LucidaGrande lblHeadingPayment;
    @BindView(R.id.et_login_email)
    EditText etLoginEmail;
    @BindView(R.id.Wrapper_login_ccname)
    TextInputLayout WrapperLoginCcname;
    @BindView(R.id.et_login_ccnumber)
    EditText etLoginCcnumber;
    @BindView(R.id.Wrapper_login_ccnumber)
    TextInputLayout WrapperLoginCcnumber;
    @BindView(R.id.et_login_expiry)
    EditText etLoginExpiry;
    @BindView(R.id.Wrapper_login_expiry)
    TextInputLayout WrapperLoginExpiry;
    @BindView(R.id.et_login_ccv)
    EditText etLoginCcv;
    @BindView(R.id.Wrapper_login_ccv)
    TextInputLayout WrapperLoginCcv;
    @BindView(R.id.ll_for_expiry_and_ccv)
    LinearLayout llForExpiryAndCcv;

    Unbinder unbinder;
    Main mainClass;

    private Charge charge;
    private ProgressDialog dialog;
    private Transaction transaction;
    private boolean expiry_clicked=false;
    private String backend_url="";

    Calendar myCalendar = Calendar.getInstance();
    DatePickerDialog.OnDateSetListener date = new DatePickerDialog.OnDateSetListener() {

        @Override
        public void onDateSet(DatePicker view, int year, int monthOfYear,
                              int dayOfMonth) {
            // TODO Auto-generated method stub
            myCalendar.set(Calendar.YEAR, year);
            myCalendar.set(Calendar.MONTH, monthOfYear);
            myCalendar.set(Calendar.DAY_OF_MONTH, dayOfMonth);
            updateLabel();
        }

    };
    private String publicKey="pk_test_46bae61647dbebecd8a4e37f6d771c6146ddd19a";


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        return init(inflater, container, savedInstanceState);
    }

    private View init(LayoutInflater inflater, ViewGroup container,
                      Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.frag_add_credit_card, container,
                false);
        unbinder = ButterKnife.bind(this, view);
        mainClass = (Main) getActivity();

        etLoginExpiry.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                expiry_clicked = true;

                DatePickerDialog datePickerDialog = new DatePickerDialog(mainClass, date, myCalendar
                        .get(Calendar.YEAR), myCalendar.get(Calendar.MONTH), myCalendar.get(Calendar.DAY_OF_MONTH));  //date is dateSetListener as per your code in question
                //datePickerDialog.getDatePicker().setMaxDate(System.currentTimeMillis());
                datePickerDialog.show();
            }
        });

        initilizePayStack();
        setFonts();
        return view;

    }



    private void updateLabel() {

        String myFormat = "MM-yyyy"; //In which you need put here
        SimpleDateFormat sdf = new SimpleDateFormat(myFormat, Locale.US);
        if (expiry_clicked) {
            etLoginExpiry.setText(sdf.format(myCalendar.getTime()));
            expiry_clicked = false;
        }

    }

    private void initilizePayStack() {

        PaystackSdk.setPublicKey(publicKey);
        //initialize sdk
        PaystackSdk.initialize(mainClass);

    }

    void setFonts() {
        Typeface type = Typeface.createFromAsset(mainClass.getAssets(), "fonts/lucidagrande.ttf");
        Typeface type1 = Typeface.createFromAsset(mainClass.getAssets(), "fonts/lucidagrandebold.ttf");
    }


    void startMainActivity() {
        Intent myIntent = new Intent(getActivity(), Main.class);
        getActivity().startActivity(myIntent);
    }


    @OnClick(R.id.btn_finish)
    public void onFinishClicked() {

        //sendToken();

        try {
            startAFreshCharge(true);
        } catch (Exception e) {

            Log.e("gokadaPayment",String.format("An error occurred while charging card: %s %s", e.getClass().getSimpleName(), e.getMessage()));

        }


    }


    @OnClick(R.id.btn_back)
    public void onViewClicked() {

        mainClass.gotoRootFragment();

    }


    private void startAFreshCharge(boolean local) {
        // initialize the charge
        charge = new Charge();
        charge.setCard(loadCardFromForm());

        dialog = new ProgressDialog(mainClass);
        dialog.setMessage("Performing transaction... please wait");
        dialog.show();

        if (local) {
            // Set transaction params directly in app (note that these params
            // are only used if an access_code is not set. In debug mode,
            // setting them after setting an access code would throw an exception

            charge.setAmount(2000);
            charge.setEmail("abc@vizteck.com");
            charge.setReference("ChargedFromAndroid_" + Calendar.getInstance().getTimeInMillis());
            try {
                charge.putCustomField("Charged From", "Android SDK");
            } catch (JSONException e) {
                e.printStackTrace();
            }
            chargeCard();
        }/* else {
            // Perform transaction/initialize on our server to get an access code
            // documentation: https://developers.paystack.co/reference#initialize-a-transaction
            new fetchAccessCodeFromServer().execute(backend_url + "/new-access-code");
        }*/
    }


    private Card loadCardFromForm() {
        //validate fields
        Card card;

        String cardNum = etLoginCcnumber.getText().toString().trim();


        //build card object with ONLY the number, update the other fields later
        card = new Card.Builder(cardNum, 0, 0, "").build();

        Log.e("gokadaPayment", String.valueOf(card.isValid()));

        String cvc = etLoginCcv.getText().toString().trim();
        //update the cvc field of the card
        card.setCvc(cvc);

        //validate expiry month;
        String expiryDate =etLoginExpiry.getText().toString().trim();

        String[] thisDate = {"", ""};

        if(!expiryDate.isEmpty() || expiryDate!=null){

            thisDate = expiryDate.split("-");

        }

        String sMonth = thisDate[0];
        int month = 0;
        try {
            month = Integer.parseInt(sMonth);
        } catch (Exception ignored) {
        }

        card.setExpiryMonth(month);

        String sYear = thisDate[1];
        int year = 0;
        try {
            year = Integer.parseInt(sYear);
        } catch (Exception ignored) {
        }
        card.setExpiryYear(year);

        return card;
    }


    private void chargeCard() {
        transaction = null;
        PaystackSdk.chargeCard(mainClass, charge, new Paystack.TransactionCallback() {
            // This is called only after transaction is successful
            @Override
            public void onSuccess(Transaction transaction) {
                dismissDialog();

                transaction = transaction;
                //mTextError.setText(" ");
                Toast.makeText(mainClass, transaction.getReference(), Toast.LENGTH_LONG).show();
                //updateTextViews();
                //new verifyOnServer().execute(transaction.getReference());
            }

            // This is called only before requesting OTP
            // Save reference so you may send to server if
            // error occurs with OTP
            // No need to dismiss dialog
            @Override
            public void beforeValidate(Transaction transaction) {
                transaction = transaction;
                Toast.makeText(mainClass, transaction.getReference(), Toast.LENGTH_LONG).show();
                //updateTextViews();
            }

            @Override
            public void onError(Throwable error, Transaction transaction) {
                // If an access code has expired, simply ask your server for a new one
                // and restart the charge instead of displaying error
                transaction = transaction;
                if (error instanceof ExpiredAccessCodeException) {
                    startAFreshCharge(true);
                    chargeCard();
                    return;
                }

                dismissDialog();

                if (transaction.getReference() != null) {
                    Toast.makeText(mainClass, transaction.getReference() + " concluded with error: " + error.getMessage(), Toast.LENGTH_LONG).show();
                    Log.e("gokadaPayment",String.format("%s  concluded with error: %s %s", transaction.getReference(), error.getClass().getSimpleName(), error.getMessage()));
                    //mTextError.setText(String.format("%s  concluded with error: %s %s", transaction.getReference(), error.getClass().getSimpleName(), error.getMessage()));
                    //new verifyOnServer().execute(transaction.getReference());
                } else {
                    Toast.makeText(mainClass, error.getMessage(), Toast.LENGTH_LONG).show();
                    Log.e("gokadaPayment",String.format("Error: %s %s", error.getClass().getSimpleName(), error.getMessage()));
                    //mTextError.setText(String.format("Error: %s %s", error.getClass().getSimpleName(), error.getMessage()));
                }
                //updateTextViews();
            }

        });
    }

    private void dismissDialog() {
        if ((dialog != null) && dialog.isShowing()) {
            dialog.dismiss();
        }
    }


    private class fetchAccessCodeFromServer extends AsyncTask<String, Void, String> {
        private String error;

        @Override
        protected void onPostExecute(String result) {
            super.onPostExecute(result);
            if (result != null) {
                charge.setAccessCode(result);
                chargeCard();
            } else {
                //MainActivity.this.mTextBackendMessage.setText(String.format("There was a problem getting a new access code form the backend: %s", error));
                Log.e("gokadaPayment",String.format("There was a problem getting a new access code form the backend: %s", error));
                dismissDialog();
            }
        }

        @Override
        protected String doInBackground(String... ac_url) {
            try {
                URL url = new URL(ac_url[0]);
                BufferedReader in = new BufferedReader(
                        new InputStreamReader(
                                url.openStream()));

                String inputLine;
                inputLine = in.readLine();
                in.close();
                return inputLine;
            } catch (Exception e) {
                error = e.getClass().getSimpleName() + ": " + e.getMessage();
            }
            return null;
        }
    }

    private class verifyOnServer extends AsyncTask<String, Void, String> {
        private String reference;
        private String error;

        @Override
        protected void onPostExecute(String result) {
            super.onPostExecute(result);
            if (result != null) {
//                MainActivity.this.mTextBackendMessage.setText(String.format("Gateway response: %s", result));
                Log.e("gokadaPayment",String.format("Gateway response: %s", result));

            } else {
//                MainActivity.this.mTextBackendMessage.setText(String.format("There was a problem verifying %s on the backend: %s ", this.reference, error));
                String.format("Gateway response: %s", String.format("There was a problem verifying %s on the backend: %s ", this.reference, error));
                dismissDialog();
            }
        }

        @Override
        protected String doInBackground(String... reference) {
            try {
                this.reference = reference[0];
                URL url = new URL(backend_url + "/verify/" + this.reference);
                BufferedReader in = new BufferedReader(
                        new InputStreamReader(
                                url.openStream()));

                String inputLine;
                inputLine = in.readLine();
                in.close();
                return inputLine;
            } catch (Exception e) {
                error = e.getClass().getSimpleName() + ": " + e.getMessage();
            }
            return null;
        }
    }

    Map<String, String> getMapofAllValues() {

        Map<String, String> map = new HashMap<String, String>();
        map.put("authorizationCode", "");

        return map;
    }


    private void sendToken() {

        if (Utilities.haveNetworkConnection(getActivity())) {
            mainClass.hideKeyboard();
            Utilities.showProgressDialog(getActivity(), "");
            WebServicesClient.getInstance().getverificationCode(getMapofAllValues(), new WebServicesCallback() {
                @Override
                public void responseReceived(Object data, JSONObject error, int statusCode) {
                    Utilities.dismissProgressDialog();
                    if (data != null) {
                        try {
                            Utilities.dismissProgressDialog();
                            JSONObject obj = (JSONObject) data;
                            if (obj.getString("success").equals("1")) {


                            } else if (obj.getString("success").equals("0")) {
                                ErrorMessages.showPromptForTitleAndMessage(Constants.ALERT_TITLE, obj.getString("message"), getActivity());
                            } else {
                                ErrorMessages.showPromptForTitleAndMessage(Constants.ALERT_TITLE, "Unknown error occured", getActivity());
                            }
                        } catch (JSONException e) {
                            e.printStackTrace();
                        }
                    } else if (error != null) {
                        try {
                            Utilities.dismissProgressDialog();
                            JSONObject obj = (JSONObject) error;
                            if (obj.getString("success").equals("0")) {
                                ErrorMessages.showPromptForTitleAndMessage(Constants.ALERT_TITLE, obj.getString("message"), getActivity());
                            } else {
                                ErrorMessages.showPromptForTitleAndMessage(Constants.ALERT_TITLE, "Unknown error occured", getActivity());
                            }
                        } catch (JSONException e) {
                            e.printStackTrace();
                        }
                    } else {
                        Utilities.dismissProgressDialog();
                        ErrorMessages.showPromptForInternet(getActivity());
                    }


                }
            });
        } else {
            ErrorMessages.showPromptForInternet(getActivity());
        }

    }




    @Override
    public void onDestroyView() {
        super.onDestroyView();
        unbinder.unbind();
    }


}
